﻿local GarrisonDone = ...

if (not GarrisonDone_Varsf) then GarrisonDone_Varsf = {} end

if (not GarrisonDoneFollowersFrame) then GarrisonDoneFollowersFrame = GarrisonDoneFollowersFrame end


local character = UnitName("player").."-"..GetRealmName();



C_Timer.After(60, function() GarrisonDone_UpdateFollowerData(data) end)

            
function GarrisonDoneFollowers_Open()        
        if GarrisonDoneFollowersFrame:IsShown() then
            GarrisonDoneFollowersFrame:Hide();
            GarrisonDoneFollowersScrollFrame:Hide();
        else
            GarrisonDoneFollowersFrame:Show();
            GarrisonDoneFollowersScrollFrame:Show();
    end
end


function GarrisonDoneFollowersScrollFrame_OnShow(self)
        if GarrisonDoneFollowersScrollFrame:IsShown() then
        GarrisonDone_UpdateFollowerData(data);
    end
end

  

         -- Collect the data of followers assigned to buildings --
function GarrisonDone_UpdateFollowerData(data)
        GarrisonDone_Varsf[GetRealmName()][GetUnitName("player")] = {};
	    for _, building, v in ipairs(C_Garrison.GetBuildings()) do
		local buildingID, buildingName, _, _, _, rank, _, _, _, _, _, _, _, _, _, _, hasFollowerSlot, _, _, _, isBeingBuilt, _, _, _, _ = C_Garrison.GetOwnedBuildingInfo(building.plotID);
		local name, level, quality, displayID, followerID, garrFollowerID, status, portraitIconID = C_Garrison.GetFollowerInfoForBuilding(building.plotID)
            if hasFollowerSlot == true then
			table.insert(GarrisonDone_Varsf[GetRealmName()][GetUnitName("player")],
            { 
            ["buildingID"] = buildingID,
            ["idName"] = buildingName,
            ["hasFollowerSlot"] = hasFollowerSlot,
            ["rank"] = rank,
                ["name"] = name,
                ["level"] = level,
				["followerID"] = followerID,
				["garrFollowerID"] = garrFollowerID,
				["status"] = status,
				["portraitIconID"] = portraitIconID,
                ["class"] = UnitClass("player"),
                ["character"] = GetUnitName("player"),
                ["realm"] = GetRealmName()
			});
        end
    end
end



 
 
        -- set locals for scroll frame --
local maxsBars = 7
local barsList = {}
local unUsedsBars = {}
local totalsBars = 0
local tempSortedList = {}
local sortsOrders = {
		{name = "Character", value = "character"},
        }
    
        -- rotate the bar frames so we dont waste resources --
function GarrisonDone_FollowersRebuild()
	local template = "GarrisonDonef_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barsList) do
		if string.find("GarrisonDonef_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedsBars[#unUsedsBars + 1] = object
			object.bars:Hide()
			barsList[index] = nil
		end
	end
	GarrisonDone_Varsf[GetRealmName()][GetUnitName("player")] = {}
	    GarrisonDone_UpdateFollowerData(data)
end
 
      
 
 
        -- Load the Bars that will make up the list --
function GarrisonDoneFollowersFrame_OnLoad(self)
	for l = 1, maxsBars, 1 do
		    bars = CreateFrame("StatusBar", "GarrisonDonef_bars_"..l, GarrisonDoneFollowersScrollFrame)
		    bars:SetWidth(300)
		    bars:SetHeight(20)
		    bars:SetOrientation("HORIZONTAL")
            local backdrop = {
                bgFile = "Interface\AddOns\GarrisonDone\images\StatusBar7",  
                edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
                tile = false,
                edgeSize = 6,
                insets = {
                    left = 1,
                    right = 1,
                    top = 1,
                    bottom = 1
                }
            }
            bars:SetBackdrop(backdrop)
            bars:Raise()
            bars:SetBackdropColor(0, 0, 0, 0.4)
		    MGDfLabel = bars:CreateFontString("GarrisonDonef_labels_"..l, "ARTWORK", "GameFontNormalMed2")
		    MGDfLabel:SetTextHeight(12)
		    MGDfLabel:SetTextColor(230, 204, 128, 10)
		    MGDfLabel:SetPoint("LEFT", 0, 0, bars)
		    MGDfLabel:SetPoint("RIGHT", bars)
		    MGDfLabel:SetJustifyH("LEFT")
		    MGDfLabel:SetNonSpaceWrap(false)
		    bars:SetPoint("TOPLEFT", "GarrisonDoneFollowersScrollFrame", 10, 20-22*(l))
		    bars:SetPoint("RIGHT", "GarrisonDoneFollowersScrollFrame", 0, 0)
	end
end



-- We have the Data now update the frame to show it - can we add a blank frame between names ?? --
function GarrisonDoneFollowersFrame_OnUpdate(elapsed)
        if GarrisonDoneFollowersFrame:IsShown() == true then
            GarrisonDoneBuildPageName:SetText("Followers Working");
			local l = 0
			local d = 0
               if GarrisonDone_Varsf then
					for realm, v1 in pairs(GarrisonDone_Varsf) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								l = l + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneFollowersScrollFrame)
								if l > offset and l <= (offset + maxsBars) then
									d = d + 1
                                    local name = data.name
								--	local t = data.endTime - time()
									local buildingID = data.buildingID
									local bars, texture, label, MGDfLabel, MGDLabel1, object
									bars = _G["GarrisonDonef_bars_"..d]
									MGDfLabel = _G["GarrisonDonef_labels_"..d]
                                    
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    MGDfLabel:SetPoint("LEFT", 8, 0, bars)
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                    end
                                        -- Shorten the Mines for Alliance --
                                    if data.idName == "Lunarfall Excavation" then data.idName = "Excavation" end
                                    
                                    
                                        -- Set Labels --
                                    if data.name ~= nil then
									MGDfLabel:SetText(string.format(color..character.." - |cffE6CC80"..data.idName.." |cff1eff00"..data.name..""))
                                	end
                                    
                                    if data.name == nil then
									MGDfLabel:SetText(string.format(color..character.." - |cffE6CC80"..data.idName.." |cffFFFC00 Gone Fishing"))
                                    -- show the Bars --
									bars:Show()
                                end
                            end								
					    end
                    end
                end
                            
			    FauxScrollFrame_Update(GarrisonDoneFollowersScrollFrame, l, maxsBars, 15)
			    if d <= maxsBars then
				    d = d + 1
				for n = d, maxsBars do
					_G["GarrisonDonef_bars_"..n]:Hide()
				    end
			    end
		    end
            if GarrisonDoneFollowersFrame:IsShown() == true then
		        GarrisonDoneFollowersScrollFrame:Show()
                GarrisonDone_UpdateFollowerData(data);
	        else
		        GarrisonDoneFollowersFrame:Hide()
                GarrisonDoneFollowersScrollFrame:Hide()
        end
    end
end

        -- old Update the Scroll Bar --
function GarrisonDoneFollowersFrame_ScrollBar_Update()
	       -- GarrisonDoneAltsFrame_OnUpdate(nil, 2) -- this was changed and now updates at 212 -- 
end

 


function GarrisonDoneFollowersSort_OnLoad()
	        for l = 1, #sortsOrders do
		    info = {
			    text = sortsOrders[l].name;
			    value = sortsOrders[l].value;
		    }
	end
end 
 
 